package com.gic.haoban.manage.web.controller;

import com.gic.api.base.commons.ServiceResponse;
import com.gic.commons.webapi.reponse.RestResponse;
import com.gic.haoban.base.api.common.pojo.dto.WebLoginDTO;
import com.gic.haoban.common.utils.AuthWebRequestUtil;
import com.gic.haoban.manage.api.dto.qdto.role.HaobanRoleQDTO;
import com.gic.haoban.manage.api.service.role.HaobanMenuApiService;
import com.gic.haoban.manage.api.service.role.HaobanRoleApiService;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RestController;

/**
 * @author mozhu
 * @date 2022/9/7 3:03 下午
 */
@RestController
@RequestMapping("/role")
public class HaobanRoleController extends WebBaseController{

    private static final Logger logger = LoggerFactory.getLogger(HaobanRoleController.class);

    @Autowired
    private HaobanRoleApiService haobanRoleApiService;
    @Autowired
    private HaobanMenuApiService haobanMenuApiService;

    /**
     * 新增
     * @param haobanRoleQDTO
     * @return
     */
    @RequestMapping(value = "/add",method = RequestMethod.POST)
    private RestResponse add(@RequestBody HaobanRoleQDTO haobanRoleQDTO) {
        WebLoginDTO login = AuthWebRequestUtil.getLoginUser();
        haobanRoleApiService.add(haobanRoleQDTO,login);
        return RestResponse.successResult();
    }

    /**
     * 修改
     * @param haobanRoleQDTO
     * @return
     */
    @RequestMapping(value = "/edit",method = RequestMethod.POST)
    private RestResponse edit(@RequestBody HaobanRoleQDTO haobanRoleQDTO) {
        WebLoginDTO login = AuthWebRequestUtil.getLoginUser();
        return RestResponse.successResult(haobanRoleApiService.edit(haobanRoleQDTO,login));
    }

    /**
     * 根据类型查询角色
     * @return
     */
    @RequestMapping(value = "/queryRoleByClerkType",method = RequestMethod.GET)
    private RestResponse queryRoleByClerkType(Integer clerkType) {
        WebLoginDTO login = AuthWebRequestUtil.getLoginUser();
        ServiceResponse serviceResponse = haobanRoleApiService.getByEnterpriseIdAndClerkType(login.getEnterpriseId(), login.getWxEnterpriseId(), clerkType);
        return RestResponse.successResult(serviceResponse.getResult());
    }

    /**
     * 根据角色查询菜单
     * @param roleId
     * @return
     */
    @RequestMapping(value = "/queryMenuByRoleId",method = RequestMethod.GET)
    private RestResponse queryMenuByRoleId(Long roleId) {
        WebLoginDTO login = AuthWebRequestUtil.getLoginUser();
        ServiceResponse serviceResponse = haobanRoleApiService.getByWxEnterpriseIdAndRoleId(login.getWxEnterpriseId(), roleId);
        return RestResponse.successResult(serviceResponse.getResult());
    }

}
